CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     RAM-based Spin Interpreter Test - Step 1                                  RamVm_Step1.spin      *
' *                                                                                                     *
' *******************************************************************************************************
'
' This is just making sure the sand-boxed environment works, that TV displays an incrementing number and
' a LED on an I/O pin can be flashed.

PRI Version

  result := String( "RamVm_Step1" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  TV_PIN        = 12

  LED_PIN       = 9
  
OBJ

  tv            : "TV_Text"


VAR

  long number

  long stack[1000]

PUB Main( running )

  tv.Start( TV_PIN )
  
  if not running
    running := true
    CogNew( SpinCode, @stack )

  repeat
    tv.Out( $01 )
    tv.Str( Version )
    tv.Out( $0D )
    Tv.Dec( number )
    
PUB SpinCode ' This must be the second method !

  DIRA[ LED_PIN ] := 1
  repeat
    number++
    ! OUTA[ LED_PIN ]
    PauseMs( 250 )

PRI PauseMs( ms )

  waitcnt( CLKFREQ / 1000 * ms + CNT )